import .connectives
import .leibniz
import .logic
import .relations
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
theorem nat.sym_eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((return) ((nat.O) ))) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.eq_filter_nat_type_O) (return_type)) (return)).
axiom nat.axiom_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))).
theorem nat.eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.axiom_filter_nat_type_S) (return_type)) (return)) (n)).
theorem nat.sym_eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((return) (((nat.S) ) (n)))) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.eq_filter_nat_type_S) (return_type)) (return)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
constant nat.plus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.plus_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_plus : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)).
theorem nat.eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.axiom_plus) (n)).
theorem nat.sym_eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) (((nat.plus) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.eq_plus) (n)).
axiom nat.axiom_plus_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m).
theorem nat.eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.axiom_plus_body_O).
theorem nat.sym_eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , m)) (((nat.plus_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.eq_plus_body_O).
axiom nat.axiom_plus_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))).
theorem nat.eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.axiom_plus_body_S) (n)).
theorem nat.sym_eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) (((nat.plus_body) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.eq_plus_body_S) (n)).
theorem nat.associative_plus : ((relations.associative) (nat.nat)) ((nat.plus) ) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (y:nat.nat) , forall (z:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (_x_365)) (y))) (z))) ((((nat.plus) ) (_x_365)) ((((nat.plus) ) (y)) (z))))) (fun (y : nat.nat) , fun (z : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) ((nat.O) )) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) ((((nat.plus) ) (y)) (z))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) ((((nat.plus) ) (y)) (z))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) ((nat.O) )) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) (((@nat.sym_eq_plus_body_O) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) ((nat.O) )) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) (((@nat.sym_eq_plus_body_O) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) ((((nat.plus) ) (y)) (z)))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (y)) (z)))))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (y:nat.nat) , forall (z:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (x_366)) (y))) (z))) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))) , (fun (y : nat.nat) , fun (z : nat.nat) , (((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (((nat.S) ) (x_366))) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) ((((nat.plus) ) (y)) (z))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) ((((nat.plus) ) (y)) (z))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((@nat.sym_eq_plus) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((x) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((((nat.plus) ) (x_366)) (y))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((x) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((@nat.sym_eq_plus_body_S) ((((nat.plus) ) (x_366)) (y))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((x) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) (((@logic.refl_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((nat.plus) ) ((((nat.plus) ) (x_366)) (y))) (z))) (((_x_368) (y)) (z)))))))))))))) (n).
